.intel_syntax noprefix
.text
.globl min_max

#void min_max(int*, int, int*, int*);
#             rdi   esi  rdx   rcx
min_max:
	enter 0,0

	#ako je duzina niza <= 0, odmah zavrsavamo funkciju
	cmp esi, 0
	jle kraj

	#inicijalno za min postavljamo vrednost prvog elementa niza
	mov r9d, [rdi]
	mov [rdx], r9d

	#inicijalno za max postavljamo vrednost prvog elementa niza
	mov r9d, [rdi]
	mov [rcx], r9d

	#koristicemo adresni pristup za prolazak kroz niz
	#cuvamo adresu kraja niza (poslednjeg elementa) u r8
	lea r8, [rdi+(rsi-1)*4]
	
petlja:
	#ukoliko smo prosli poslednji element niza, zavrsavamo
	cmp rdi, r8
	ja kraj

	#ispitujemo da li je tekuci element niza manji od trenutnog min
	#(opet mora iz 2 koraka da ne bismo imali 2 memorijska operanda)
	mov r9d, [rdi]
	cmp r9d, [rdx]
	jl promeni_min

	#ispitujemo da li je tekuci element niza veci od trenutnog max
	#(opet mora iz 2 koraka da ne bismo imali 2 memorijska operanda)
	mov r9d, [rdi]
	cmp r9d, [rcx]
	jg promeni_max

	#inace, idemo na sledeci element niza
	jmp sledeca_iteracija

promeni_min:
	#znamo da je u r9d trenutni element niza
	#smestamo ga na adresu za min (rdx)
	mov [rdx], r9d

	jmp sledeca_iteracija

promeni_max:
	#znamo da je u r9d trenutni element niza
	#smestamo ga na adresu za max (rcx)
	mov [rcx], r9d

	jmp sledeca_iteracija

sledeca_iteracija:
	#pomeramo se na naredni element niza 
	add rdi, 4

	jmp petlja

kraj:
	leave
	ret

