.intel_syntax noprefix
.text
.global bin_pretraga

#int bin_pretraga(char*, int, char);
#eax               rsi   esi   dl

bin_pretraga:
	enter 0, 0

	#koristicemo indeksni pristup za prolazak kroz niz

	#u r8d cuvamo indeks levog elementa (inicijalno 0)
	xor r8d, r8d

	#u esi cuvamo indeks desnog elementa (inicijalno n-1)
	#u esi se vec nalazi n, pa je samo umanjujemo za 1
	dec esi

petlja:
	#ukoliko su indeksi levog i desnog elementa mimoisli,
	#to znaci da smo sveli problem na pretrazivanje praznog
	#niza, pa zakljucujemo da trazeni element nije pronadjen
	cmp r8d, esi
	ja nije_pronadjen

	#u r10d racunamo indeks sredisnjeg elementa dela niza 
	#koji pretrazuejmo (po formuli: (levi+desni)/2)
	mov r10d, r8d 
	add r10d, esi
	shr r10d, 1

	#poredimo sredisnji element sa trazenim i pri tom 
	#razlikujemo tri slucaja:
	# - ako su jednaki vracamo indeks sredisnjeg elementa
	#   i zavrsavamo funkciju
	# - ako je sredisnji element manji od trazenog dalje
	#   nastavljamo sa pretragom u desnoj polovini niza
	# - ako je sredisnji element veci od trazenog dalje
	#   nastavljamo sa pretragom u levoj polovini niza
	cmp [rdi+r10*1], dl
	je jeste_pronadjen
	jl idi_desno
	jg idi_levo

idi_desno:
	#azuriramo indeks levog elementa na indeks sredisnjeg +1
	mov r8d, r10d
	inc r8d
	
	jmp petlja

idi_levo:
	#azuriramo indeks desnog elementa na indeks sredisnjeg -1
	mov esi, r10d
	dec esi

	jmp petlja

jeste_pronadjen:
	#vracamo indeks sredisnjeg elementa
	mov eax, r10d
	jmp kraj
  
nije_pronadjen:
	#vracamo proizvoljnu negativnu vrednost
	mov eax, -1
	jmp kraj

kraj:
	leave
	ret
