.intel_syntax noprefix
.text
.global dekadni_niz

#funkcija za obrtanje niza iz 4. zadatka 
#samo za niz sa 4-bajtnim elementima
obrni:
	enter 0,0

	#r8d = levi_indeks = 0
	xor r8d, r8d

	#esi = desni_indeks = n-1
	dec esi
	
petlja_obrni:
	cmp r8d, esi
	jge kraj_obrni

	#zamenjujemo vrednosti levog i desnog elementa
	mov edx, [rdi+r8*4]
	mov ecx, [rdi+rsi*4]
	mov [rdi+r8*4], ecx
	mov [rdi+rsi*4], edx

	#uvecavamo levi_indeks
	inc r8d

	#umanjujemo desni_indeks
	dec esi
	
	jmp petlja_obrni

kraj_obrni:
	leave
	ret

#void dekadni_niz(unsigned, unsigned*, int*);
#                   edi       rsi      rdx
dekadni_niz:
	enter 0, 0

	#IDEJA:
	#i = 0;
	#do{
	#	niz[i] = broj%10;
	#	i++;
	#	broj = broj/10;
	#}while(broj!=0);
	#n = i;

	#koristicemo adresni pristup za prolazak kroz niz
	#odnosno, u registru rsi cemo drzati adresu za upis 
	#sledeceg elementa niza (sledece izdvojene cifre)

	#u ecx cuvamo dosadasnju duzinu niza
	xor ecx, ecx

	#u r11 cuvamo kopiju adrese pocetka niza jer cemo je
	#izgubiti u procesu izdvajanja cifara i upisivanja
	#elemenata u niz adresnim pristupom (ukoliko bismo
	#koristili indeksni pristup ovo ne bi bilo neophodno)
	#adresa pocetka niza ce nam biti potrebna kasnije da
	#je prosledimo funkciji za obrtanje niza 
	mov r11, rsi

	#u r8d upisujemo vrednost 10 da bismo mogli kroz 
	#registarski operand da prosledimo vrednost 10 kao 
	#operand za instrukciju div (nije moguce proslediti
	#vrednost 10 kao neposredni operant instrukciji div!)
	mov r8d, 10

petlja_dekadni_niz:
	#spremamo se za deljenje broja sa 10
	mov eax, edi

	#moramo da sacuvamo sadrzaj registra rdx (&n) na steku jer
	#nam je registar rdx potreban za izvrsenje instrukcije div
	push rdx

	#neoznaceno prosirujemo eax na edx:eax
	xor edx, edx
	
	#delimo sa 10
	div r8d

	#u edx je ostatak pri deljenju (poslednja cifra 
	#broja), i to upisujemo kao sledeci element niza 
	mov [rsi], edx

	#u eax je kolicnik (broj bez poslednje cifre),
	#i to upisujemo u edi - broj za sledecu iteraciju  
	mov edi, eax

	#vracamo u rdx sacuvanu vrednost sa steka
	pop rdx

	#pomeramo pokazivac rsi za jedno mesto u nizu kako 
	#bismo se pripremili za upis sledece cifre broja
	add rsi, 4

	#povecavamo brojac cifara
	inc ecx

	#proveravamo uslov izlaska iz petlje
	test edi, edi
	jz kraj_dekadni_niz

	#u suprotnom skacemo na pocetak petlje
	jmp petlja_dekadni_niz

kraj_dekadni_niz:
	#upisujemo duzinu niza koju smo sracunali u ecx
	mov [rdx], ecx

	#na samom kraju cemo pozvati funkciju obrni kako bismo 
	#cifre  dobili u redosledu u kom se pojavljuju, od cifre 
	#najvece tezine do cifre najmanje tezine (primetimo da 
	#smo ih izdvajali i upisivali u niz pocev od poslednje!)

	#prvi operand za funkciju obrni jeste adresa pocetka niza
	#u r11 smo sacuvali kopiju adrese pocetka niza jer smo je
	#izgubiti u procesu izdvajanja cifara i upisivanja
	#elemenata u niz adresnim pristupom 
	mov rdi, r11
	
	#drugi operand za funkciju obrni jeste duzina niza
	mov esi, ecx

	call obrni

	#NAPOMENA: ovde nije potrebno cuvali pre poziva funkcije 
	#'obrni' vrednosti registara koje koristimo na steku zato 
	#sto nam te vrednosti nece biti potrebne nakon funkcije
	#'obrni' - jer odmah zavrsavamo funkciju dekadni_niz!
	
	leave
	ret

